<template>
  <div :id="id" class="emoji-popup-content">
    <div class="emoji-chooser">
      <div ref="scrollRef" class="emoji-chooser__scroll" @scroll="onScroll">
        <div v-for="category in categories" :key="category.code" class="emoji-chooser__category">
          <h4 :class="`emoji-chooser-category-${category.code}`">
            {{ category.displayName }}
          </h4>
          <div class="emoji-chooser__grid">
            <button
              v-for="emoji in category.emojis"
              :key="emoji.markdown"
              class="emoji-chooser__tile"
              :title="emoji.markdown"
              @click="onClickEmoji(emoji)"
            >
              <span>
                {{ emoji.unicode }}
              </span>
            </button>
          </div>
        </div>
      </div>
      <div class="emoji-chooser__nav">
        <ul>
          <li v-for="category in categories" :key="category.code">
            <a
              :class="[
                `emoji-chooser-nav-${category.code}`,
                {
                  active: activeCategoryCode === category.code,
                },
              ]"
              :title="category.displayName"
              @click="onClickCategory(category)"
            >
              {{ category.icon }}
            </a>
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
import { ref, nextTick } from 'vue'
import EmojisHelper from '../../../lib/emojis/emojis-helper.js'

export default {
  name: 'EmojiPopupContent',
  emits: ['clickEmoji'],
  props: {
    id: { type: String, required: true },
  },
  setup(_, context) {
    const scrollRef = ref(null)

    const categories = ref(EmojisHelper.getCategories())
    const offsetsCalculated = ref(false)
    const activeCategoryCode = ref(categories.value[0].code)

    const onScroll = async (event) => {
      await ensureCategoryOffsets()
      const scrollTop = event.target.scrollTop
      const activeCategory = getActiveCategory(scrollTop)
      activeCategoryCode.value = activeCategory.code
    }

    const onClickEmoji = (emoji) => {
      context.emit('clickEmoji', emoji)
    }

    const onClickCategory = (category) => {
      ensureCategoryOffsets().then(() => {
        const categoryWithOffset = categories.value.find((x) => x.code === category.code)
        scrollRef.value.scrollTop = categoryWithOffset.offsetTop
      })
    }

    const ensureCategoryOffsets = async () => {
      if (offsetsCalculated.value) {
        return
      }

      categories.value = categories.value.map((category) => ({
        ...category,
        offsetTop: document.querySelector(`.emoji-chooser-category-${category.code}`).offsetTop,
      }))
      offsetsCalculated.value = true

      await nextTick()
    }

    const getActiveCategory = (scrollTop) => {
      return this.categories.filter((category) => category.offsetTop <= scrollTop).pop()
    }

    return {
      categories,
      offsetsCalculated,
      activeCategoryCode,

      onScroll,
      onClickEmoji,
      onClickCategory,
    }
  },
}
</script>

<style lang="scss">
@use '../../../sass/vars';

$scrollbarWidth: 17px;
$spacing: 1em;
$panelColor: white;
$lightTextColor: #999999;
$circleColor: #e0e0e0;
$hoverColor: #e7e7e7;
$activeColor: cornflowerblue;

$emojiTileSize: 34px;
$emojiTileCircleSize: 28px;
$emojiTileEmojiSize: 24px;
$emojiTilesWide: 8;
$emojiTilesHigh: 6;
$emojiNavEmojiSize: 16px;
$emojiNavTileSize: 32px;

$emojiTileCircleMarginSize: calc(($emojiTileSize - $emojiTileCircleSize) / 2);
$emojiContentWidth: $emojiTileSize * $emojiTilesWide + $scrollbarWidth;
$emojiContentHeight: calc($emojiTileSize * $emojiTilesHigh + $spacing + $emojiNavTileSize);

.tui-editor-defaultUI {
  .emoji-chooser {
    display: flex;
    flex-flow: column;
    position: relative;
  }

  .emoji-chooser__scroll {
    width: $emojiContentWidth;
    height: $emojiTileSize * $emojiTilesHigh;
    overflow-x: hidden;
    overflow-y: auto;
    scrollbar-width: thin;
  }

  .emoji-chooser__category h4 {
    font-weight: normal;
    font-size: 1em;
    height: $emojiTileSize;
    line-height: $emojiTileSize;
    padding-left: calc(($emojiTileSize - $emojiTileCircleSize) / 2);
    color: $lightTextColor;
  }

  .emoji-chooser__category:first {
    margin-top: 0;
  }

  .emoji-chooser__grid {
    display: flex;
    flex-wrap: wrap;
  }

  .emoji-chooser__tile {
    font-size: 20px;
    scroll-snap-align: start;
    border: none;
    background-color: transparent;
    display: block;
    width: $emojiTileSize;
    height: $emojiTileSize;
    padding: 0;
    margin: 0;
    position: relative;

    > span {
      display: block;
      width: $emojiTileCircleSize;
      height: $emojiTileCircleSize;
      margin: $emojiTileCircleMarginSize;
      border-radius: 50%;
      background-color: $circleColor;
      overflow: visible;

      > span {
        position: absolute;
        display: block;
        cursor: pointer !important;
        left: 0;
        top: 0;
        width: $emojiTileSize;
        height: $emojiTileSize;
        line-height: $emojiTileSize;
        text-align: center;
        font: calc($emojiTileEmojiSize / $emojiTileSize) sans-serif;
      }
    }

    &:hover {
      text-decoration: none;
      background-color: transparent;

      > span {
        background-color: $hoverColor;
      }
    }
  }

  .emoji-chooser__nav ul {
    display: flex;
    width: $emojiContentWidth;
    justify-content: center;
    margin: $spacing 0 0 0;
    padding: 0;

    li {
      display: block;
      margin: 0;
      padding: 0;

      a {
        display: block;
        cursor: pointer !important;
        width: $emojiNavTileSize;
        height: $emojiNavTileSize;
        line-height: $emojiNavTileSize;
        border-radius: 3px;
        font: calc($emojiNavEmojiSize / $emojiNavTileSize) sans-serif;
        margin: 0;
        text-align: center;

        &:hover {
          text-decoration: none;
          background-color: $hoverColor;
        }
      }

      a.active {
        background-color: $activeColor;
      }
    }
  }
}
</style>
